(load "sudoku.scm")

(define drawnboard (testing-board))
;; Make a 302 × 302 frame
(define frame (instantiate frame% ("sudoku") (width 302) (height 302)))
;; Make the drawing area
(define canvas (instantiate canvas% (frame) 
                            (paint-callback (lambda (canvas dc) (draw-sudoku-callback dc)))))
;; Get the canvas's drawing context
(define dc (send canvas get-dc))

;; Make some pens and brushes
(define no-pen (instantiate pen% ("BLACK" 1 'transparent)))
(define thin-pen (instantiate pen% ("BLACK" 1 'solid)))
(define thick-pen (instantiate pen% ("BLACK" 3 'solid)))
(define no-brush (instantiate brush% ("BLACK" 'transparent)))
(define blue-brush (instantiate brush% ("BLUE" 'solid)))
(define yellow-brush (instantiate brush% ("YELLOW" 'solid)))
(define red-brush (instantiate brush% ("RED" 'solid)))
(define red-pen (instantiate pen% ("RED" 2 'solid)))
;;make some color objects
(define blue (make-object color% 0 0 255))
(define black (make-object color% 0 0 0))

;; render the board, called on window refresh
(define (draw-sudoku-callback dc) ;;er, sorry this is gross but it does the job.
  ;; to learn more about graphics in DrScheme, look at 
  ;; http://download.plt-scheme.org/doc/352/html/mred/mred.html#node_toc_node_chap_5
  (send dc set-brush no-brush) 
  (let loop ((pad 0))
    (if (or(eq? pad 99)(eq? pad 198))
        (send dc set-pen thick-pen)
        (send dc set-pen thin-pen))
    (send dc draw-line (+ 2 pad) 2 (+ 2 pad) 299)
    (send dc draw-line 2 (+ 2 pad) 299 (+ 2 pad))
    (if (< pad 299) (loop (+ pad 33)))) 
  (let loopy ((pady 0) (boardIndex 0))
    (let loopx ((padx 0) (boardIndex boardIndex))
      (let* ((cell (get-cell-by-number drawnboard boardIndex))
             (val (cell-values cell)))
        (if (findf (lambda (x)(eq? x 'given)) cell)
            (send dc set-text-foreground blue)
            (send dc set-text-foreground black))
        (if (and(pair? val)(null? (cdr val)))
            (send dc draw-text (number->string (car val)) (+ 15 padx)(+ 11 pady)))
        (if ( = padx (* 33 8))
            (if (< pady (* 33 8))
                (loopy (+ pady 33)(+ boardIndex 1)))
            (loopx (+ padx 33)(+ boardIndex 1)))))))

;; draw board -- can be called from pset code
(define (draw-board b)
  (set! drawnboard b)
  (send frame show #t) 
  (draw-sudoku-callback dc))
                
        

  


