;; Public test cases for problem set 1
(load "ps3.scm")
(load "tester-utils.scm")

(begin-test-suite)

(begin
  ;;;sudoku
  (define theboard (testing-board))
  (test 1 '(can-propagate? (get-cell-by-number theboard 0)) '#f)
  (test 1 '(can-propagate? (get-cell-by-number theboard 1)) '#t)
  
  (test 1 '(propagate-one-cell (get-cell-by-number theboard 1) (list (get-cell-by-number theboard 0))) '#t)
  (test 1 '(propagate-one-cell (get-cell-by-number theboard 1) (list (get-cell-by-number theboard 0))) '#f)
  (test 1 '(cell-values (get-cell-by-number theboard 0)) '(1 3 4 5 6 7 8 9))
  
  (set! theboard (testing-board))
  (test 1 '(propagate-one-round theboard) '#t)

  (set! theboard (testing-board))
  (test 5 '(begin
             (constraint-propagate theboard 0)
             (summarize-board theboard))
        '((5)(2)(8)(6)(9)(3)(4)(7) (1)(6)(3)(9)(7)(1)(4)(5)(8)(2)(7)(4)(1)(8)(2)(5)(6)(9)(3)(8) (5)
          (2)(9)(3)(6) (7) (1) (4) (9) (6)(3)(1)(4)(7)(8)(2)(5)(1)(7)(4)(2)(5)(8)(9)(3)(6)(4)(1)(7)
          (5)(8)(2)(3)(6)(9)(3)(9)(6)(4)(7)(1)(2)(5)(8)(2)(8)(5)(3)(6)(9)(1)(4)(7)))
  (draw-board theboard) ;;comment me out if you don't want to see the board window anymore!
  
  (test 1 'answer-2.1.1 3)
  (test 1 'answer-2.1.2 2)
  
  (define winning-board '(position W ((W 1 1) (W 4 3) (B 3 3))))
  (define winning-board2 '(position B ((B 1 4) (B 4 2) (W 3 2))))
    
  (test 1 '(get-move (minimax-search winning-board 4 'W #t focused-evaluate))
        '(position B ((W 4 4) (W 1 1) (B 3 3))))
  (test 1 '(get-move (minimax-search winning-board 6 'W #t focused-evaluate))
        '(position B ((W 4 4) (W 1 1) (B 3 3))))
  (test 1 '(get-move (minimax-search winning-board2 4 'B #t focused-evaluate))
        '(position W ((B 4 1) (B 1 4) (W 3 2))))
  (test 1 '(get-move (minimax-search winning-board2 6 'B #t focused-evaluate))
        '(position W ((B 4 1) (B 1 4) (W 3 2))))
  (test 1 '(get-move (minimax-search winning-board 4 'B #t focused-evaluate))
        '(position B ((W 1 2) (W 4 3) (B 3 3))))
  (test 1 '(get-move (minimax-search winning-board 6 'B #t focused-evaluate))
        '(position B ((W 1 2) (W 4 3) (B 3 3))))

  ; First, make sure that minimax is counting the right number of nodes.
  ; This makes sure you didn't mess with minimax.
  (test 1 '(begin 
             (define counting-evaluate (make-counter simple-evaluate))
             (minimax-search startpos 6 'W #t counting-evaluate)
             (counting-evaluate 'count))
        4610)
  
  ; Alpha-beta should count drastically fewer nodes.
  ; If you get a different number, check your implementation against the
  ; one in the text, and remember to check moves from left to right.
  (test 1 '(begin 
             (define counting-evaluate (make-counter simple-evaluate))
             (alpha-beta-search startpos 6 'W #t counting-evaluate -2000 2000)
             (counting-evaluate 'count))
        316)
  (test 1 '(begin 
             (define counting-evaluate (make-counter simple-evaluate))
             (alpha-beta-search startpos 7 'W #t counting-evaluate -2000 2000)
             (counting-evaluate 'count))
        382)
  (test 1 '(begin 
             (define counting-evaluate (make-counter simple-evaluate))
             (alpha-beta-search startpos 8 'W #t counting-evaluate -2000 2000)
             (counting-evaluate 'count))
        712)
  (test 1 '(begin 
             (define counting-evaluate (make-counter simple-evaluate))
             (alpha-beta-search startpos 9 'W #t counting-evaluate -2000 2000)
             (counting-evaluate 'count))
        1228)

  ;; You are not necessarily expected to pass all these tests.
  ;; The number of points you get is the number of games you win, of these 10. So 5 points are essentially free.
  (test 1 '(play-game startpos (alpha-beta-player 3 better-evaluate) (alpha-beta-player 3 simple-evaluate)) 'W)
  (test 1 '(play-game startpos (alpha-beta-player 3 simple-evaluate) (alpha-beta-player 3 better-evaluate)) 'B)
  (test 1 '(play-game startpos (alpha-beta-player 4 better-evaluate) (alpha-beta-player 4 simple-evaluate)) 'W)
  (test 1 '(play-game startpos (alpha-beta-player 4 simple-evaluate) (alpha-beta-player 4 better-evaluate)) 'B)
  (test 1 '(play-game startpos (alpha-beta-player 5 better-evaluate) (alpha-beta-player 5 simple-evaluate)) 'W)
  (test 1 '(play-game startpos (alpha-beta-player 5 simple-evaluate) (alpha-beta-player 5 better-evaluate)) 'B)
  (test 1 '(play-game startpos (alpha-beta-player 6 better-evaluate) (alpha-beta-player 6 simple-evaluate)) 'W)
  (test 1 '(play-game startpos (alpha-beta-player 6 simple-evaluate) (alpha-beta-player 6 better-evaluate)) 'B)
  (test 1 '(play-game startpos (alpha-beta-player 7 better-evaluate) (alpha-beta-player 7 simple-evaluate)) 'W)
  (test 1 '(play-game startpos (alpha-beta-player 7 simple-evaluate) (alpha-beta-player 7 better-evaluate)) 'B)
 
  (test-short-answer 0 'how-many-hours-this-pset-took)
  (test-short-answer 0 'what-i-found-interesting)
  (test-short-answer 0 'what-i-found-boring)
    
  (end-test-suite))
